# TBasicAttributesSetControler Class Reference

Inheritance diagram for TBasicAttributesSetControler:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | QueryInterface (const MCIID &riid, void **ppvObj)
virtual uint32 MCCOMAPI | AddRef ()
virtual boolean MCCOMAPI | ShowControllerOnObjects () const
virtual int32 MCCOMAPI | GetSubControllerCount ()
virtual boolean MCCOMAPI | IsSubControllerActive (int32 subControllerIndex)
virtual void MCCOMAPI | InvalidateAttributesMapping ()
virtual void MCCOMAPI | ComputeAttributeForRead (TParamHolder &value, int32 paramIndex, int32 subControllerIndex, IAttributeValueHelper *helper)
virtual boolean MCCOMAPI | ComputeAttributeForWrite (TParamHolder &value, int32 paramIndex, int32 subControllerIndex, boolean record, IAttributeCurrentValueHelper *valueHelper, IAttributeValueHelper *helper)
virtual void MCCOMAPI | AttributeModified (int32 paramIndex)
virtual void MCCOMAPI | AttributeInvalidated (int32 paramIndex)

## Member Function Documentation

virtual uint32 MCCOMAPI TBasicAttributesSetControler::AddRef | ( |  | ) | `[inline, virtual]`

Increments the reference count of the object

Reimplemented from TBasicDataExchanger.

virtual void MCCOMAPI TBasicAttributesSetControler::AttributeInvalidated | ( | int32 | paramIndex | ) | `[inline, virtual]`

Called when an attribute has been invalidated (ie. its value will be check by the next CheckParamForRead().

Parameters:

  | paramIndex | The index of the parameter in the clip.

Implements I3DExAttributesSetControler.

virtual void MCCOMAPI TBasicAttributesSetControler::AttributeModified | ( | int32 | paramIndex | ) | `[inline, virtual]`

Called when an attribute has been modified.

Parameters:

  | paramIndex | The index of the parameter in the clip.

Implements I3DExAttributesSetControler.

virtual void MCCOMAPI TBasicAttributesSetControler::ComputeAttributeForRead | ( | TParamHolder & | value,
|  | int32 | paramIndex,
|  | int32 | subControllerIndex,
|  | IAttributeValueHelper * | helper |
| ) |  |  | `[inline, virtual]`

virtual boolean MCCOMAPI TBasicAttributesSetControler::ComputeAttributeForWrite | ( | TParamHolder & | value,
|  | int32 | paramIndex,
|  | int32 | subControllerIndex,
|  | boolean | record,
|  | IAttributeCurrentValueHelper * | valueHelper,
|  | IAttributeValueHelper * | helper |
| ) |  |  | `[inline, virtual]`

virtual int32 MCCOMAPI TBasicAttributesSetControler::GetSubControllerCount | ( |  | ) | `[inline, virtual]`

Returns the number of sub controllers. A controller can contains multiple sub controllers. In that case, the functions ComputeAttributeForRead and ComputeAttributeForWrite will be called multiple times.

Implements I3DExAttributesSetControler.

virtual void MCCOMAPI TBasicAttributesSetControler::InvalidateAttributesMapping | ( |  | ) | `[inline, virtual]`

This function is called when the mapping of the attributes changed. This function is not called everytime something change, but only when a validation is needed (before a call to ComputeAttributeForRead() for instance). You should validate the caches that you need to update during that function. This call is protected in SMP so it is safe to do so. Doing it in ComputeAttributeForRead is not protected.

Implements I3DExAttributesSetControler.

virtual boolean MCCOMAPI TBasicAttributesSetControler::IsSubControllerActive | ( | int32 | subControllerIndex | ) | `[inline, virtual]`

Returns true if the given sub controller can modify some parameter value. If not the sub controller will not be called.

Parameters:

  | subControllerIndex | The index of the sub controller.

Implements I3DExAttributesSetControler.

virtual MCCOMErr MCCOMAPI TBasicAttributesSetControler::QueryInterface | ( | const MCIID & | riid,
|  | void ** | ppvObj |
| ) |  |  | `[virtual]`

Check if the object supports a given interface and returns a pointer to that interface if it does. Note that QueryInterface will increment the reference count of the object by one if the interface is found.

Parameters:

  | riid | GUID of the interface
  | ppvObj | A pointer to the pointer being returned.

Reimplemented from TBasicDataExchanger.

virtual boolean MCCOMAPI TBasicAttributesSetControler::ShowControllerOnObjects | ( |  | ) | const`[inline, virtual]`

Returns true if the controller UI shall be visible on all objects part of the attributes set.

See also:
  I3DShAttributesSet

Implements I3DExAttributesSetControler.

The documentation for this class was generated from the following file:

- BasicAttributesSetControler.h